
#include "mcp3208.h"

unsigned int mcp3208_read(unsigned char channel, unsigned char mode)
{
  union {
    struct {
      unsigned char lsb;
      unsigned char msb;
    } u8;
    unsigned int u16;
  } dataw;

#ifndef VREF_4096
  unsigned long int adc_data;
#endif  
  
  dataw.u16 = (channel << 6);	 	// set adc input channel (0,,,7)
  dataw.u8.msb |= ((0x02 | mode) << 1);	// set adc input mode (0 = diff.,1 = single)
 
  cbi(PORTB,4);				// enable slave (SS pin)			

  outp(dataw.u8.msb,SPDR);		// sends dataw1
  while(bit_is_clear(SPSR,SPIF));	// wait until bit SPIF is set
  
  outp(dataw.u8.lsb,SPDR);		// sends dataw2
  while(bit_is_clear(SPSR,SPIF));	// wait until bit SPIF is set

  dataw.u8.msb=inp(SPDR) & 0x0f;	// read msb data (ignore 1st 4 bits)

  outp(0,SPDR);				// sends dataw3
  while(bit_is_clear(SPSR,SPIF));	// wait until bit SPIF is set

  sbi(PORTB,4);				// dis. slave (end)

  dataw.u8.lsb=inp(SPDR);		// read lsb data word

#ifndef VREF_4096
  adc_data = dataw.u16;			// apply scale correction: ref.voltage = 5000 mV
  dataw.u16 = (unsigned int)((12207 * adc_data) / 10000);	// 2^12 bits = 4096
#endif  							// 5000/4096 = 1.2207

  return (dataw.u16);			// return millivolts;
}
